(* Title: "BridgeLibisabelle/thy-hierarchy.sml"
   Authors: Walther Neuper 060113
   (c) due to copyright terms

theory Test_Some imports Isac.Build_Thydata begin 
ML_file "$ISABELLE_ISAC_TEST/Tools/isac/ADDTESTS/accumulate-val/lucas_interpreter.sml"
ML_file "xmlsrc/thy-hierarchy.sml"

CAUTION with testing *2file functions -- they are actually writing to ~/tmp
*)

val thy = @{theory "Isac_Knowledge"};

"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- fun thms_of_rlss ------------------------------------";
"----------- fun get_fun_ids -------------------------------------------------------------------";
"-----------------------------------------------------------------";
"----------- gen.minimal KEStore_Elems from Test_Build_Thydata.thy";
"----------- ..CONTINUED: we adapt some required MINIfunctions ---";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";

"----------- fun thms_of_rlss ------------------------------------";
"----------- fun thms_of_rlss ------------------------------------";
"----------- fun thms_of_rlss ------------------------------------";

val rlss = 
  [("empty" : Rule_Set.id, ("Know_Store": ThyC.id, Rule_Set.empty)),
  ("discard_minus" : Rule_Set.id, ("Poly": ThyC.id, discard_minus))];

val [_, (thmID, term)] = Thy_Hierarchy.thms_of_rlss thy rlss;

if thmID = "Poly.real_mult_minus1_sym"
then () else error "thms_of_rlss changed";

"~~~~~ fun thms_of_rlss, args:"; val (thy, rlss) = (@{theory Isac_Knowledge}, rlss);
val rlss' = (rlss : (Rule_Set.id * (ThyC.id * Rule_Set.T)) list)
  |> map (Thy_Hierarchy.thms_of_rls o #2 o #2)
    (* = [[], [Thm ("real_diff_minus", "?a - ?b = ?a + - 1 * ?b"), 
      Thm ("sym_real_mult_minus1", "- ?z1 = - 1 * ?z1")]]*)
  |> flat
    (* = [Thm ("real_diff_minus", "?a - ?b = ?a + - 1 * ?b"), 
      Thm ("sym_real_mult_minus1", "- ?z1 = - 1 * ?z1")]*)
  |> map (ThmC.revert_sym_rule thy)
    (* = [Thm ("Poly.real_diff_minus", "?a - ?b = ?a + - 1 * ?b"), 
      Thm ("Delete.real_mult_minus1", "- 1 * ?z = - ?z")] : rule list*)
  |> map (fn Thm (thmID, thm) => (thmID, Thm.prop_of thm))
    (* = [("Poly.real_diff_minus", Const (\<^const_name>\<open>Trueprop\<close>, "bool \<Rightarrow> prop") $ ...,
      ("Delete.real_mult_minus1", Const (\<^const_name>\<open>Trueprop\<close>, ...)] : (string * term) list*)
  |> distinct (fn ((thmID1, thm1), (thmID2, thm2)) => thmID1 = thmID2);


"----------- fun get_fun_ids -------------------------------------------------------------------";
"----------- fun get_fun_ids -------------------------------------------------------------------";
"----------- fun get_fun_ids -------------------------------------------------------------------";
val met_fun_ids = Thy_Hierarchy.get_fun_ids @{theory Biegelinie};
if map fst (Thy_Hierarchy.get_fun_ids @{theory Biegelinie}) = 
  ["Biegelinie.function_to_equality", "Biegelinie.biegelinie", "Biegelinie.belastung_zu_biegelinie",
    "Biegelinie.setzte_randbedingungen"] then () else error "get_fun_ids changed"


"----------- gen.minimal KEStore_Elems from Test_Build_Thydata.thy";
"----------- gen.minimal KEStore_Elems from Test_Build_Thydata.thy";
"----------- gen.minimal KEStore_Elems from Test_Build_Thydata.thy";
  val isacrlsthms = KEStore_Elems.get_rlss @{theory Test_Build_Thydata}
(*                         CHANGE FOR CODE \<up> \<up> \<up> \<up> \<up> \<up> \<up> \<up>  \<up> *)
    |> remove (fn (rlsID, (rls', (_, _))) => rlsID = rls') "prog_expr" (*unpleasant in test*)
    |> remove (fn (rlsID, (rls', (_, _))) => rlsID = rls') "e_rrls"   (*unpleasant in test*)
    |> remove (fn (rlsID, (rls', (_, _))) => rlsID = rls') "empty"    (*unpleasant in test*)
    |> Thy_Hierarchy.thms_of_rlss @{theory}            (*length =  4*)

  val rlsthmsNOTisac = isacrlsthms       (*length =  2*)
    |> filter (fn (deriv, _) => 
      member op= (map Context.theory_name isabthys') (ThyC.cut_id deriv))
;
val (knowthys', progthys') = ([@{theory Test_Build_Thydata}], [@{theory Test_Build_Thydata}])
;
val thydata_list = 
  Thy_Hierarchy.collect_part       "IsacKnowledge" knowledge_parent knowthys' @
  (map (Thy_Hierarchy.collect_isab "Isabelle") rlsthmsNOTisac) @
  Thy_Hierarchy.collect_part       "IsacScripts" proglang_parent progthys' (* only the thms, no rls *)
;
case thydata_list of                     (*length =  8*)
  [(["IsacKnowledge", "Test_Build_Thydata", "Theorems", "thm111"],
    Thy_Write.Hthm {coursedesign = [], fillpats = [], guh = "thy_isac_Test_Build_Thydata-thm-thm111", 
    mathauthors = ["isac-team"], thm = _}),
  (["IsacKnowledge", "Test_Build_Thydata", "Theorems", "thm222"],
    Thy_Write.Hthm {coursedesign = [], fillpats = [], guh = "thy_isac_Test_Build_Thydata-thm-thm222", 
    mathauthors = ["isac-team"], thm = _}),
  (["IsacKnowledge", "Test_Build_Thydata", "Rulesets", "rls111"],
    Thy_Write.Hrls {coursedesign = [], guh = "thy_isac_Test_Build_Thydata-rls-rls111", 
    mathauthors = ["isac-team"], thy_rls = ("Test_Build_Thydata", Rule_Set.Repeat _)}),
  (["IsacKnowledge", "Test_Build_Thydata", "Rulesets", "rls222"],
    Thy_Write.Hrls {coursedesign = [], guh = "thy_isac_Test_Build_Thydata-rls-rls222", 
    mathauthors = ["isac-team"], thy_rls = ("Test_Build_Thydata", Rule_Set.Repeat _)}),
  (["Isabelle", "HOL", "Theorems", "refl"],
    Thy_Write.Hthm {coursedesign = [], fillpats = [], guh = "thy_isab_HOL-thm-refl", 
    mathauthors = ["Isabelle team, TU Munich"], thm = _}),
  (["Isabelle", "Fun", "Theorems", "o_def"], Thy_Write.Hthm {coursedesign = [], fillpats = [], 
    guh = "thy_isab_Fun-thm-o_def", mathauthors = ["Isabelle team, TU Munich"], thm = _}),
  (["IsacScripts", "Test_Build_Thydata", "Theorems", "thm111"],
    Thy_Write.Hthm {coursedesign = [], fillpats = [], guh = "thy_scri_Test_Build_Thydata-thm-thm111", 
    mathauthors = ["isac-team"], thm = _}),
  (["IsacScripts", "Test_Build_Thydata", "Theorems", "thm222"],
    Thy_Write.Hthm {coursedesign = [], fillpats = [], guh = "thy_scri_Test_Build_Thydata-thm-thm222", 
    mathauthors = ["isac-team"], thm = _})] => ()
| _ => error "collect thydata from Test_Build_Thydata changed";
;
(* we store locally on MINIthehier instead on Know_Store, see Know_Store: *)
    fun add_the (thydata, theID) = Thy_Write.add_thydata ([], theID) thydata;
val thes = map (fn (a, b) => (b, a)) thydata_list
val MINIthehier = (fold add_the thes) (KEStore_Elems.get_thes @{theory Test_Build_Thydata});

"----------- ..CONTINUED: we adapt some required MINIfunctions ---";
"----------- ..CONTINUED: we adapt some required MINIfunctions ---";
"----------- ..CONTINUED: we adapt some required MINIfunctions ---";
fun MINIget_the (theID : Thy_Write.theID) = Store.get MINIthehier theID theID (*see ptyps.sml*)
fun MINIthy_hierarchy2file (path:Pbl_Met_Hierarchy.filepath) = 
  (*Pbl_Met_Hierarchy.str2file*) (path ^ "thy_hierarchy.xml",
    "<NODE>\n" ^
    "  <ID> theory hierarchy </ID>\n" ^
    "  <NO> 1 </NO>\n" ^
    "  <CONTENTREF> thy_ROOT </CONTENTREF>\n" ^
    (Thy_Hierarchy.hierarchy_guh MINIthehier) ^
    "</NODE>");
if MINIthy_hierarchy2file "xxx/" =
   ("xxx/thy_hierarchy.xml",
    "<NODE>\n  <ID> theory hierarchy </ID>\n  <NO> 1 </NO>\n  <CONTENTREF> thy_ROOT </CONTENTREF>\n  <NODE>\n    <ID> IsacKnowledge </ID>\n    <NO> 1 </NO>\n    <CONTENTREF> thy_isac_IsacKnowledge-part </CONTENTREF>\n    <NODE>\n      <ID> Test_Build_Thydata </ID>\n      <NO> 1 </NO>\n      <CONTENTREF> thy_isac_Test_Build_Thydata </CONTENTREF>\n      <NODE>\n        <ID> Theorems </ID>\n        <NO> 1 </NO>\n        <CONTENTREF> thy_isac_Test_Build_Thydata-Theorems </CONTENTREF>\n        <NODE>\n          <ID> thm111 </ID>\n          <NO> 1 </NO>\n          <CONTENTREF> thy_isac_Test_Build_Thydata-thm-thm111 </CONTENTREF>\n        </NODE>\n        <NODE>\n          <ID> thm222 </ID>\n          <NO> 2 </NO>\n          <CONTENTREF> thy_isac_Test_Build_Thydata-thm-thm222 </CONTENTREF>\n        </NODE>\n      </NODE>\n      <NODE>\n        <ID> Rulesets </ID>\n        <NO> 2 </NO>\n        <CONTENTREF> thy_isac_Test_Build_Thydata-Rulesets </CONTENTREF>\n        <NODE>\n          <ID> rls111 </ID>\n          <NO> 1 </NO>\n          <CONTENTREF> thy_isac_Test_Build_Thydata-rls-rls111 </CONTENTREF>\n        </NODE>\n        <NODE>\n          <ID> rls222 </ID>\n          <NO> 2 </NO>\n          <CONTENTREF> thy_isac_Test_Build_Thydata-rls-rls222 </CONTENTREF>\n        </NODE>\n      </NODE>\n    </NODE>\n  </NODE>\n  <NODE>\n    <ID> Isabelle </ID>\n    <NO> 2 </NO>\n    <CONTENTREF> thy_isab_Isabelle-part </CONTENTREF>\n    <NODE>\n      <ID> HOL </ID>\n      <NO> 1 </NO>\n      <CONTENTREF> thy_isab_HOL </CONTENTREF>\n      <NODE>\n        <ID> Theorems </ID>\n        <NO> 1 </NO>\n        <CONTENTREF> thy_isab_HOL-Theorems </CONTENTREF>\n        <NODE>\n          <ID> refl </ID>\n          <NO> 1 </NO>\n          <CONTENTREF> thy_isab_HOL-thm-refl </CONTENTREF>\n        </NODE>\n      </NODE>\n    </NODE>\n    <NODE>\n      <ID> Fun </ID>\n      <NO> 2 </NO>\n      <CONTENTREF> thy_isab_Fun </CONTENTREF>\n      <NODE>\n        <ID> Theorems </ID>\n        <NO> 1 </NO>\n        <CONTENTREF> thy_isab_Fun-Theorems </CONTENTREF>\n        <NODE>\n          <ID> o_def </ID>\n          <NO> 1 </NO>\n          <CONTENTREF> thy_isab_Fun-thm-o_def </CONTENTREF>\n        </NODE>\n      </NODE>\n    </NODE>\n  </NODE>\n  <NODE>\n    <ID> IsacScripts </ID>\n    <NO> 3 </NO>\n    <CONTENTREF> thy_scri_IsacScripts-part </CONTENTREF>\n    <NODE>\n      <ID> Test_Build_Thydata </ID>\n      <NO> 1 </NO>\n      <CONTENTREF> thy_scri_Test_Build_Thydata </CONTENTREF>\n      <NODE>\n        <ID> Theorems </ID>\n        <NO> 1 </NO>\n        <CONTENTREF> thy_scri_Test_Build_Thydata-Theorems </CONTENTREF>\n        <NODE>\n          <ID> thm111 </ID>\n          <NO> 1 </NO>\n          <CONTENTREF> thy_scri_Test_Build_Thydata-thm-thm111 </CONTENTREF>\n        </NODE>\n        <NODE>\n          <ID> thm222 </ID>\n          <NO> 2 </NO>\n          <CONTENTREF> thy_scri_Test_Build_Thydata-thm-thm222 </CONTENTREF>\n        </NODE>\n      </NODE>\n    </NODE>\n  </NODE>\n</NODE>")
then () else error "MINIthy_hierarchy2file CHANGED";

